/* 
//
// Modified 'GetCurrentEditorElement' function (override that in 'comm.jar/editor/content/editorUtilities.js')
var currentEditor = {};
var documentUrl = "";
function GetCurrentEditorElement() {
  //~ var tmpWindow = window;
  // Kaze: modified to point at the top window (so GetCurrentEditor and other functions work in the site manager)
  var tmpWindow = window.top;
  
  do {
    // Get the <editor> element(s)
    var tabeditor = tmpWindow.document.getElementById("tabeditor");

    // This will change if we support > 1 editor element
    if (tabeditor )
      return tabeditor.getCurrentEditorElement() ;

    tmpWindow = tmpWindow.opener;
  } 
  while (tmpWindow);

  return null;
} 
*/
//~ var NsmStringBundle2 = document.getElementById("NsmBundle");
function getNsmBundle2(id) {
	//~ return NsmStringBundle2.getString("NsmConText-" + id);
	try {
		var txt = document.getElementById("NsmBundle").getString("NsmConText-" + id);
	} catch (e) {
		var txt = id;
	};
	return txt;
}
//
// Modified 'loadExternalURL' function (override that in 'comm.jar/editor/content/ComposerCommands.js')
var NsmPreviewAppRef = -1;
function loadExternalURL(url) {
	if (!url) try {
		//~ url = GetNsmItem().url;
		url = GetDocumentUrl();
	} catch (e) {};
	
	if (url) {
		if (NsmPreviewAppRef >= 0) { // launch custom browser
			//~ var AppPath = LaunchyContext.apps[NsmPreviewAppRef].exe;
			NsmLaunch(NsmPreviewAppRef, url);
			NsmPreviewAppRef = -1; // reset to default browser
		} else { // launch default browser
			var ioService = Components.classes["@mozilla.org/network/io-service;1"]
				.getService(Components.interfaces.nsIIOService);
			var uri = ioService.newURI(url, null, null);
			var extProtocolSvc = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
				.getService(Components.interfaces.nsIExternalProtocolService);
			extProtocolSvc.loadUrl(uri);
		}
	}
}
//
// Editor toolbar button
var NsmEditorAppRef = -1;
function NsmEditPage(e) {
	var appRef = NsmEditorAppRef;
	NsmEditorAppRef == -1; // disable this line to keep the last selected editor as default editor
	//~ alert(appRef);
	
	var url = GetDocumentUrl();
	if ((url == "about:blank") || (e.button != 0))
		return;
	
	if (appRef == -2)  { // reload current page
		NsmExternalEditorLastMod = 0;
		if (IsDocumentModified()) {
			nsRevertCommand.doCommand();
		} else {
			CancelHTMLSource();
			EditorLoadUrl(GetDocumentUrl());
		}
	} else { // edit current page
		if (IsDocumentModified())
			nsSaveCommand.doCommand();
		NsmExternalEditorLastMod = getLastMod();
		
		if (appRef == -1)  {
			// Launch default editor
			try {
				var AppPath = NsmPrefs.getCharPref("extEditor");
				NsmLaunchExe(AppPath, url);
			} catch (e) {};
		} else {
			// Launch selected editor
			NsmLaunch(appRef, url);
		}
	} 
	NsmEditorAppRef == -1; // disable this line to keep the last selected editor as default editor
	return;
}
//
// Modified 'EditorOnFocus' function (override that in 'comm.jar/editor/content/editor.js')
// for user notification after an external editor is launched
var NsmExternalEditorLastMod = 0;
var NsmExternalEditorProcess = null;

function getLastMod() {
	// ref = http://www.xulplanet.com/references/xpcomref/comps/c_filelocal1.html
	var time = 0;
	try {
		var path = NsmFileIO.urlToPath(GetDocumentUrl());
		var file = NsmFileIO.newLocalFile(path);
		time = file.lastModifiedTime;
	} catch (e) {};
	return time;
}

function EditorOnFocus() {
  // Current window already has the InsertCharWindow
  if ("InsertCharWindow" in window && window.InsertCharWindow) return;

  // Find window with an InsertCharsWindow and switch association to this one
  var windowWithDialog = FindEditorWithInsertCharDialog();
  if (windowWithDialog)
  {
    // Switch the dialog to current window
    // this sets focus to dialog, so bring focus back to editor window
    if (SwitchInsertCharToThisWindow(windowWithDialog))
      top.document.commandDispatcher.focusedWindow.focus();
  }
  
	// <Kaze>
	var NsmEditButton = top.document.getElementById("NsmEditButton");
	if (NsmEditButton) {
		// disable button if document is distant or blank
		var url = GetDocumentUrl();
		var isBlank = (url == "about:blank");
		//~ var isBlank = ( (url == "about:blank") || (GetScheme(url) != "file") );
		NsmEditButton.disabled = isBlank;
		
		// reset globals
		var lastMod = NsmExternalEditorLastMod;
		NsmExternalEditorLastMod = 0;
		NsmEditorAppRef = -1;
		
		// test if the file has been modified
		if ( (!isBlank) && (lastMod > 0) ) {
			if (lastMod != getLastMod()) {
				// file has been modified, ask whether to accept or reject modifications
				if (ConfirmWithTitle("NsmConText", 
					getNsmBundle2("Edit-Warning"), 
					getNsmBundle2("Edit-Accept"), 
					getNsmBundle2("Edit-Discard") ) 
				) { // Accept changes
					CancelHTMLSource(); // useless?
					EditorLoadUrl(url); // reload document in Nvu
				} else { // Discard changes
					nsSaveCommand.doCommand(); // save Nvu's document to discard changes
				}
			}
		}
	}
	// </Kaze>
}

//
// editorOverlay.xul (navigator preview, source and element editing)
function addNsmPreviews(menuid) {
	NsmClearMenu(menuid);
	NsmAppendLaunchyItems(menuid, 1, "NsmPreviewAppRef=(#)");
}

function addNsmEditSource(menuid) {
	var url = GetDocumentUrl();
	
	NsmClearMenu(menuid);
	if (GetScheme(url) == "file") {
		NsmAppendLaunchyItems(menuid, 7, "NsmEditorAppRef=(#)");
	}
	try { // useless with Nvu 1.0 release
		NsmAppendMenuSeparator(menuid);
		NsmAppendMenuItem(menuid, "reload", "NsmEditorAppRef=(-2);");
		//~ NsmAppendMenuItem(menuid, getNsmBundle2("Reload"), "NsmEditorAppRef=(-2);");
	} catch (e) {};
}
function addNsmEditLink(menuid) {
	var url = GetCurrentEditor().getSelectedElement("href").href;
	var launch = "NsmLaunch(#, '" + url + "');";
	var isFile = (GetScheme(url) == "file");

	NsmClearMenu(menuid);
	
	// HTML documents
	if (!IsHiddenByFilter("html", url)) {
		// edit in a new tab/window
		var editNewTab = "window.editPage('" + url + "', window.top, true, true)";
		var editNewPage = "window.editPage('" + url + "', window.top, true, false)";
		try {
			//~ var NsmStringBundle = document.getElementById("NsmBundle");
			//~ NsmAppendMenuItem(menuid, NsmStringBundle.getString("NsmConText-NewTab"), editNewTab);
			//~ NsmAppendMenuItem(menuid, NsmStringBundle.getString("NsmConText-NewWindow"), editNewPage);
			var NsmStringBundle = document.getElementById("NsmBundle");
			NsmAppendMenuItem(menuid, getNsmBundle2("NewTab"), editNewTab);
			NsmAppendMenuItem(menuid, getNsmBundle2("NewWindow"), editNewPage);
			NsmAppendMenuSeparator(menuid);
		} catch (e) {};
		// show editors and browsers
		NsmAppendEditors(menuid, url);
		NsmAppendBrowsers(menuid, url);
	}
	// Server-side scripts (edit local files)
	else if (!IsHiddenByFilter("cgi", url) && isFile) {
		NsmAppendEditors(menuid, url, true);
	}
	// images (edit local files)
	else if (!IsHiddenByFilter("images", url) && isFile) {
		NsmAppendLaunchyItems(menuid, 8, launch);
		NsmAppendMenuSeparator(menuid);
	}
	// media (edit local files)
	else if (!IsHiddenByFilter("media", url) && isFile) {
		NsmAppendLaunchyItems(menuid, 3, launch);
		NsmAppendMenuSeparator(menuid);
	}
	// other files
	else {
		NsmAppendBrowsers(menuid, url, true);
	}
	// signature
	NsmAppendSignature(menuid);
}
function addNsmEditImage(menuid) {
	var url = GetObjectForProperties().src;
	var launch = "NsmLaunch(#, '" + url + "');"
	//~ var isFile = (GetScheme(url) == "file");
	
	NsmClearMenu(menuid);
	NsmAppendLaunchyItems(menuid, 8, launch);
	NsmAppendMenuSeparator(menuid);
	NsmAppendSignature(menuid);
}
function addNsmEditPHP(menuid) {
/*	var link = GetCurrentEditor().getElementOrParentByTagName("php", GetObjectForProperties());
	//~ var php = link.firstChild.nodeValue;
	var php = link.firstChild.innerHTML;
	
	// Text editors
	NsmClearMenu(menuid);
	NsmAppendLaunchyItems(menuid, 7, "NsmLaunchAndNotify(#)");
	
	// debug
	NsmAppendMenuSeparator(menuid);
	NsmAppendMenuItem(menuid, php, "NsmReloadPage();");
*/	
	NsmClearMenu(menuid);
	NsmAppendMenuItem(menuid, "coming soon !", "loadExternalURL('http://en.wikipedia.org/wiki/Teasing');");
	
	NsmAppendMenuSeparator(menuid);
	NsmAppendSignature(menuid);
}

//
// Main: called when showing the editor's popup menu
function NsmEditorContentContext(event, contextMenuNode) {
	if ( event.target != contextMenuNode )
		return;
	
	// do what Nvu has to do (= original "onpopupshowing" attribute content) ;-)
	try {
		EditorFillContextMenu(event, contextMenuNode); 
		RealTimeSpell.updateMenu('spellSuggestionsMenu','spellSuggestionsMenuSeparator');
	} catch (e) {};
	
	// Setup object property menuitem
	var objectName = InitObjectPropertiesMenuitem("objectProperties_cm");
	var isPHP = (objectName == "php");
	var isInLink = (objectName == "href");
	var isImage = (objectName == "img");
	if (isImage) try { // Special case of an image inside a link
		isInLink = GetCurrentEditor().getElementOrParentByTagName("href", GetObjectForProperties());
	} catch (e) {}
	
	// show or hide menus
	ShowMenuItem("NsmECC-php", isPHP);
	ShowMenuItem("NsmECC-img", isImage); // show only for local files ???
	ShowMenuItem("NsmECC-href", isInLink);	// TODO: if the link points to the same page, show "follow" instead of this menu
	//~ document.getElementById("NsmECC-img").hidden = !isImage
	//~ document.getElementById("NsmECC-href").hidden = !isInLink
	ShowMenuItem("editLink_cm", false); // moved to the "Link" popup menu
}
//
//
